var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var csv_exports = {};
__export(csv_exports, {
  default: () => csv_default
});
module.exports = __toCommonJS(csv_exports);
var import_minimal_csv_formatter = __toESM(require("minimal-csv-formatter"));
var import_fp = __toESM(require("lodash/fp.js"));
let transformLabels = import_fp.default.map(import_fp.default.get("label"));
var csv_default = ({
  stream,
  // writable stream target stream
  iterableData,
  // iterator for each page of an array of objects
  // order list of which indicates the header label,
  // display function for the field,
  // and key of the record.
  // [{ key: string(supports lodash dot notation), label: string, display: function(value, {key, record, transform})}...]
  transform,
  //TODO: support multi-line headers in excel and csv when implemented
  headers = null,
  // array of strings to use as headers
  onWrite = import_fp.default.noop
  // function to intercept writing a page of records
}) => {
  stream.write((0, import_minimal_csv_formatter.default)(headers || transformLabels(transform)));
  let cancel = false;
  let recordsWritten = 0;
  return {
    promise: (async () => {
      for await (let r of iterableData) {
        if (cancel)
          break;
        stream.write(
          (0, import_minimal_csv_formatter.default)(
            import_fp.default.map(
              (t) => t.display(import_fp.default.get(t.key, r), {
                key: t.key,
                record: r,
                transform
              }),
              transform
            )
          )
        );
        recordsWritten = recordsWritten + import_fp.default.getOr(1, "recordCount", r);
        await onWrite({ recordsWritten, record: r });
      }
      await onWrite({ recordsWritten, isStreamDone: true });
      await stream.end();
    })(),
    cancel() {
      cancel = true;
    }
  };
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
