var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var excel_exports = {};
__export(excel_exports, {
  default: () => excel_default
});
module.exports = __toCommonJS(excel_exports);
var import_fp = __toESM(require("lodash/fp.js"));
var import_futil = __toESM(require("futil"));
var import_node = __toESM(require("write-excel-file/node"));
let transformLabels = import_fp.default.map(import_fp.default.get("label"));
let maxColumnWidth = 200;
let headerBackgroundColor = "#999999";
let indexColumnBackgroundColor = "#bbbbbb";
const convertToExcelCell = (value, index) => {
  return {
    wrap: true,
    value: value ? `${value}` : ``,
    ...index === 0 && { backgroundColor: indexColumnBackgroundColor } || {}
  };
};
var excel_default = ({
  stream,
  // writable stream target stream
  readStreamData = async (data, options) => await (0, import_node.default)(data, options),
  iterableData,
  // iterator for each page of an array of objects
  // order list of which indicates the header label,
  // display function for the field,
  // and key of the record.
  // [{ key: string(supports lodash dot notation), label: string, display: function(value, {key, record, transform})}...]
  transform,
  //TODO: support multi-line headers in excel and csv when implemented
  headers = null,
  // array of strings to use as headers
  onWrite = import_fp.default.noop
  // function to intercept writing a page of records
}) => {
  const excelData = [
    import_fp.default.map(
      (value) => ({
        value,
        fontWeight: "bold",
        backgroundColor: headerBackgroundColor
      }),
      headers || transformLabels(transform)
    )
  ];
  let cancel = false;
  let recordsWritten = 0;
  let columns = import_fp.default.map(
    (column) => ({ width: column.value.length }),
    excelData[0]
  );
  return {
    promise: (async () => {
      for await (let r of iterableData) {
        if (cancel)
          break;
        let row = import_futil.default.mapIndexed(
          (data, index) => convertToExcelCell(
            data.display(import_fp.default.get(data.key, r), {
              key: data.key,
              record: r,
              transform
            }),
            index
          ),
          transform
        );
        columns = import_futil.default.mapIndexed(
          (value, index) => ({
            width: Math.min(
              Math.max(value.width, row[index].value.length),
              maxColumnWidth
            )
          }),
          columns
        );
        excelData.push(row);
        recordsWritten = recordsWritten + import_fp.default.getOr(1, "recordCount", r);
        await onWrite({ recordsWritten });
      }
      const readStream = await readStreamData(excelData, {
        columns,
        stickyRowsCount: 1
      });
      for await (const chunk of readStream) {
        stream.write(chunk);
      }
      await onWrite({ recordsWritten, isStreamDone: true });
      await stream.end();
    })(),
    cancel() {
      cancel = true;
    }
  };
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
