var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var pivot_exports = {};
__export(pivot_exports, {
  default: () => pivot_default,
  getGroupingSize: () => getGroupingSize
});
module.exports = __toCommonJS(pivot_exports);
var import_fp = __toESM(require("lodash/fp.js"));
var import_futil = __toESM(require("futil"));
var import_contexture_client = __toESM(require("contexture-client"));
var import_pivot = require("contexture-client/exampleTypes/pivot.js");
var import_utils = require("../utils.js");
let getPageSize = (grouping) => {
  let pageSizeGetters = {
    fieldValues: import_fp.default.getOr(10, "size")
  };
  return import_fp.default.getOr(import_fp.default.noop, grouping.type, pageSizeGetters)(grouping);
};
let getGroupingSize = (node, groupType, countResult, exportAllPages) => import_futil.default.reduceTree(import_fp.default.get(groupType))(
  (result, groupResult, index, parents) => {
    let childSize = import_fp.default.size(import_fp.default.get(groupType, groupResult));
    let groupSize = import_fp.default.getOr(childSize, `${groupType}GroupCount`, groupResult);
    if (!groupSize)
      return result;
    if (!exportAllPages) {
      let grouping = import_fp.default.get([groupType, import_fp.default.size(parents)], node);
      groupSize = import_fp.default.min([groupSize, getPageSize(grouping)]);
    }
    return result + groupSize;
  },
  1,
  // starting with 1 for the total column/row
  countResult
);
var pivot_default = async ({ service, tree, exportAllPages, ...node }) => {
  let run = (node2) => (0, import_utils.runWith)(service, tree, node2);
  let getContextureClient = (tree2, node2) => (0, import_contexture_client.default)(
    {
      service,
      debounce: 0
    },
    (0, import_utils.andGroup)((0, import_utils.setFilterOnly)(tree2), node2)
  );
  let getGroupingResult = async (type) => {
    let groups = import_fp.default.cloneDeep(import_fp.default.get(type, node));
    if (import_fp.default.isEmpty(groups))
      return {};
    import_futil.default.mergeOn(import_fp.default.last(groups), { groupCounts: true, skip: true });
    if (exportAllPages)
      import_fp.default.each(import_fp.default.setOn("groupCounts", true), groups);
    let countNode = await run({
      ...node,
      columns: import_fp.default.map(import_fp.default.set("skip", true), node.columns),
      rows: import_fp.default.map(import_fp.default.set("skip", true), node.rows),
      [type]: groups,
      // getting only groups for this type
      values: import_fp.default.map(import_fp.default.set("skip", true), node.values),
      expansions: [],
      expanded: {
        [type]: true
      }
    });
    return import_fp.default.get("context.results", countNode);
  };
  let columnGroupingResult = await getGroupingResult("columns");
  let rowGroupingResult = await getGroupingResult("rows");
  let columnGroupingSize = getGroupingSize(
    node,
    "columns",
    columnGroupingResult,
    exportAllPages
  );
  let rowGroupingSize = getGroupingSize(
    node,
    "rows",
    rowGroupingResult,
    exportAllPages
  );
  let valuesSize = import_fp.default.size(node.values) || 1;
  let pivotSize = columnGroupingSize * rowGroupingSize * valuesSize;
  let pivot = {
    node: {
      ...node,
      context: { results: { ...columnGroupingResult, ...rowGroupingResult } }
    },
    getTotalRecords() {
      return pivotSize;
    },
    async *[Symbol.asyncIterator]() {
      let search = getContextureClient(tree, {
        ...node,
        expanded: {
          columns: true
        }
      });
      await search.refresh(["root"]);
      let cNode = pivot.node = search.getNode(["root-parent", node.key]);
      let yieldRows = async function* (drilldown) {
        let result = (0, import_pivot.resultsForDrilldown)(
          "rows",
          drilldown,
          import_fp.default.get("context.results", cNode)
        );
        let index = 0;
        let level = import_fp.default.size(drilldown);
        for (let row of result.rows) {
          let path = [...drilldown, (0, import_pivot.getKey)(row)];
          yield {
            ...row,
            path,
            index: index++,
            level,
            recordCount: getGroupingSize(node, "columns", row, exportAllPages) * valuesSize,
            rows: void 0
            // removing children rows to avoid memory leaks
          };
          if (import_fp.default.size(drilldown) < import_fp.default.size(cNode.rows) - 1) {
            await cNode.expand("rows", path);
            yield* yieldRows(path);
            cNode.collapse("rows", path);
          }
        }
      };
      yield* yieldRows([]);
      let totalRow = import_fp.default.get("context.results", cNode);
      yield {
        ...totalRow,
        isTotalRow: true,
        path: [],
        index: 0,
        level: -1,
        recordCount: getGroupingSize(node, "columns", totalRow, exportAllPages) * valuesSize,
        rows: void 0
        // removing children rows to avoid memory leaks
      };
    }
  };
  return pivot;
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  getGroupingSize
});
