import F from "futil";
import _ from "lodash/fp.js";
import { runWith, flattenProp } from "../utils.js";
let resultField = (field, node) => F.cascade([`response.${field}`, field], node.context);
var results_default = async ({ service, tree, ...node }) => {
  let { page = 1, pageSize = 100 } = node;
  let run = (props) => runWith(
    service,
    tree,
    F.omitNil({
      key: "results",
      type: "results",
      ...node,
      ...props
    })
  );
  let scrollId;
  let totalRecords = resultField(
    "totalRecords",
    await run({ pageSize: 1, page: 1 })
  );
  let results = {
    getTotalRecords() {
      return totalRecords;
    },
    async *[Symbol.asyncIterator]() {
      let next = run({ page, scrollId, skipCount: true });
      while (page <= Math.ceil(totalRecords / pageSize)) {
        let cNode = results.node = await next;
        scrollId = cNode.context.scrollId;
        next = run({ page: page + 1, scrollId, skipCount: true });
        page++;
        for (let r of _.map(
          flattenProp("_source"),
          resultField("results", cNode)
        ))
          yield r;
      }
    }
  };
  return results;
};
export {
  results_default as default
};
