import _ from "lodash/fp.js";
import { runWith } from "../utils.js";
var terms_stats_default = async ({ service, tree, ...node }) => {
  let { key_field, size = 100 } = node;
  let run = (node2) => runWith(service, tree, node2);
  let totalRecords = _.get(
    "context.value",
    await run({
      key: "cardinality",
      type: "cardinality",
      field: key_field,
      fieldMode: "autocomplete"
    })
  );
  let terms_stats = {
    getTotalRecords() {
      return totalRecords;
    },
    async *[Symbol.asyncIterator]() {
      let cNode = terms_stats.node = await run({
        ...node,
        key: "stats",
        type: "terms_stats",
        key_field,
        size: size || totalRecords
      });
      for (let t of _.getOr([], "context.terms", cNode))
        yield t;
    }
  };
  return terms_stats;
};
export {
  terms_stats_default as default
};
