import F from "futil";
import _ from "lodash/fp.js";
let Tree = F.tree((x) => x.children);
let setFilterOnly = Tree.transform((x) => {
  x.filterOnly = true;
});
let andGroup = (...args) => {
  let children = _.flatten(args);
  let [{ schema, key }] = children;
  return { key: `${key}-parent`, type: "group", join: "and", schema, children };
};
let lastChild = _.flow(_.get("children"), _.last);
let runWith = async (service, tree, node) => lastChild(await service(andGroup(setFilterOnly(tree), node)));
let flattenProp = _.curry(
  (prop, target) => _.flow(F.expandObject(_.get(prop)), _.unset(prop))(target)
);
export {
  andGroup,
  flattenProp,
  runWith,
  setFilterOnly
};
